package easyNotify;

import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;
import org.omg.PortableServer.POAPackage.*;

/**
 * Consommateur d'vnements structurs.
 *
 * Attention, il n'y a pas de cration de POA : on utilise celui pass en paramtre.
 **/

public class EasyNotifyStructuredPullConsumer extends EasyNotifyConsumer {



    StructuredProxyPullSupplier structuredProxyPullSupplier;
    StructuredPullConsumerImpl structuredPullConsumerImpl;
    POA poa;

    public EasyNotifyStructuredPullConsumer(ORB orb)
	throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb);
	completeConstruction(orb, poa);
    }
    
    public EasyNotifyStructuredPullConsumer(ORB orb, POA poa, Property[] initialQoS, Property[] initialAdmin)throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb, initialQoS, initialAdmin);
	completeConstruction(orb, poa);
    }

    public EasyNotifyStructuredPullConsumer(org.omg.CORBA.ORB orb, POA poa, String notificationServiceMachine, String notificationServicePort) throws org.omg.CORBA.SystemException , org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin{
	super(orb, notificationServiceMachine, notificationServicePort);
	completeConstruction(orb, poa);
    }

    public EasyNotifyStructuredPullConsumer(ORB orb, POA poa, int channelId) throws ChannelNotFound, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb, channelId);
	completeConstruction(orb, poa);
    }

    public EasyNotifyStructuredPullConsumer(org.omg.CORBA.ORB orb, POA poa, String notificationServiceMachine, String notificationServicePort, int channelId) throws org.omg.CORBA.SystemException, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin, org.omg.CosNotifyChannelAdmin.ChannelNotFound {
	super(orb, notificationServiceMachine, notificationServicePort, channelId);
	completeConstruction(orb, poa);
    }


    private void completeConstruction(org.omg.CORBA.ORB orb, POA poa) {
	this.poa = poa;

	// cration d'un POA pour la bte
	Policy[] pl = new Policy[2];
	pl[0] = poa.create_lifespan_policy(
		    org.omg.PortableServer.LifespanPolicyValue.PERSISTENT);
	pl[1] = poa.create_id_assignment_policy(
	 	    org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID);

	// construction de l'objet qui va recevoir les requtes et les
	// faire passer  celui qui doit les traiter
	System.out.println("cration de l'implementation serveur qui rcupere les evenements");
	structuredPullConsumerImpl = new StructuredPullConsumerImpl(orb, poa); 
    }




    public void connect() throws org.omg.CosNotifyChannelAdmin.AdminLimitExceeded, org.omg.CosEventChannelAdmin.AlreadyConnected {
	// partie commune  tous les consommateurs
	System.out.println("Connexion d'un consumer");
	startConnect();


	// partie spcifique  un consommateur de ce type
	ProxySupplier proxySupplier = consumerAdmin.obtain_notification_pull_supplier(ClientType.STRUCTURED_EVENT, proxySupplierId);
	structuredProxyPullSupplier = StructuredProxyPullSupplierHelper.narrow(proxySupplier);


	// connexion effective
	try {
	    poa.activate_object(structuredPullConsumerImpl);
	    org.omg.CosNotifyComm.StructuredPullConsumer consumer = structuredPullConsumerImpl._this(orb);
	    structuredProxyPullSupplier.connect_structured_pull_consumer(consumer);
	} catch (org.omg.PortableServer.POAPackage.ServantAlreadyActive e) {
	    System.err.println("Servant dj actif");
	} catch (org.omg.PortableServer.POAPackage.WrongPolicy e) {
	    System.err.println("Mauvaise politique");
	}
    }

    
    public void disconnect() {
	System.out.println("Dconnexion");
	structuredProxyPullSupplier.disconnect_structured_pull_supplier();
    }


    public StructuredEvent pull() {
	StructuredEvent event = null;
	try {
	    //System.out.println("pull");
	    event = structuredProxyPullSupplier.pull_structured_event();
	}
	catch(org.omg.CosEventComm.Disconnected ex) {
	    ex.printStackTrace();
	}
	return event;
	
    }

    public StructuredEvent try_pull(BooleanHolder has_event) {
	StructuredEvent event = null;
	try {
	    //System.out.println("try pull");
	    //BooleanHolder has_event = new BooleanHolder();
	    event = structuredProxyPullSupplier.try_pull_structured_event(has_event);
	}
	catch(org.omg.CosEventComm.Disconnected ex) {
	    ex.printStackTrace();
	}
	return event;
	
    }

}
	
