package easyNotify;


import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;


public class EasyNotifyStructuredPullSupplier extends EasyNotifySupplier{


    protected StructuredProxyPullConsumer structuredProxyPullConsumer;
    protected StructuredPullSupplierImpl structuredPullSupplierImpl;
    protected POA poa;
    /**
     * pointeur vers l'objet qui doit recevoir les notifications
     **/
    protected EasyStructuredPullEventDealer eventDealer;

    public EasyNotifyStructuredPullSupplier(ORB orb, POA poa, EasyStructuredPullEventDealer eventDealer) throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb);
	completeConstruction(orb, poa, eventDealer);
    }
    
    public EasyNotifyStructuredPullSupplier(ORB orb, POA poa, Property[] initialQoS, Property[] initialAdmin, EasyStructuredPullEventDealer eventDealer) throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin{
	super(orb, initialQoS, initialAdmin);
	completeConstruction(orb, poa, eventDealer);
    }

    public EasyNotifyStructuredPullSupplier(org.omg.CORBA.ORB orb, POA poa, String notificationServiceMachine, String notificationServicePort, EasyStructuredPullEventDealer eventDealer) throws org.omg.CORBA.SystemException, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb, notificationServiceMachine, notificationServicePort);
	completeConstruction(orb, poa, eventDealer);
    }

    public EasyNotifyStructuredPullSupplier(ORB orb, POA poa, int channelId, EasyStructuredPullEventDealer eventDealer) throws ChannelNotFound , org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin{
	super(orb, channelId);
	completeConstruction(orb, poa, eventDealer);
    }

    public EasyNotifyStructuredPullSupplier(org.omg.CORBA.ORB orb, POA poa, String notificationServiceMachine, String notificationServicePort, int channelId, EasyStructuredPullEventDealer eventDealer) throws org.omg.CORBA.SystemException, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin, org.omg.CosNotifyChannelAdmin.ChannelNotFound {
	super(orb, notificationServiceMachine, notificationServicePort, channelId);
	completeConstruction(orb, poa, eventDealer);
    }


    private void completeConstruction(org.omg.CORBA.ORB orb, POA poa, EasyStructuredPullEventDealer eventDealer) {
	this.poa = poa;

	this.eventDealer = eventDealer;

	// cration d'un POA pour la bte
	Policy[] pl = new Policy[2];
	pl[0] = poa.create_lifespan_policy(
		    org.omg.PortableServer.LifespanPolicyValue.PERSISTENT);
	pl[1] = poa.create_id_assignment_policy(
	 	    org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID);

	// construction de l'objet qui va recevoir les requtes et les
	// faire passer  celui qui doit les traiter
	System.out.println("cration de l'implementation serveur qui rcupere les evenements");
	structuredPullSupplierImpl = new StructuredPullSupplierImpl(orb, poa, eventDealer); 
    }


    public void connect() throws org.omg.CosNotifyChannelAdmin.AdminLimitExceeded, org.omg.CosEventChannelAdmin.AlreadyConnected {
	startConnect();
	System.out.println("rcupration du proxy");
	
	ProxyConsumer proxyConsumer = supplierAdmin.obtain_notification_pull_consumer(ClientType.STRUCTURED_EVENT, proxyConsumerId);
	structuredProxyPullConsumer = StructuredProxyPullConsumerHelper.narrow(proxyConsumer);
	
	System.out.println("connexion sans callback");
	// connexion sans notification des changements ventuels
	try{
	    poa.activate_object(structuredPullSupplierImpl);
	    org.omg.CosNotifyComm.StructuredPullSupplier supplier = structuredPullSupplierImpl._this(orb);
	    structuredProxyPullConsumer.connect_structured_pull_supplier(supplier);
	}
	catch(org.omg.CosEventChannelAdmin.TypeError te){
	    te.printStackTrace();
	} catch (org.omg.PortableServer.POAPackage.ServantAlreadyActive e) {
	    System.err.println("Servant dj actif");
	} catch (org.omg.PortableServer.POAPackage.WrongPolicy e) {
	    System.err.println("Mauvaise politique");
	}
    }


    public void disconnect(){
	System.out.println("dconnexion");
	structuredProxyPullConsumer.disconnect_structured_pull_consumer();
    }
    

    /**
     * lancer un vnement
     **/
    /*    public void pull(EasyStructuredEvent event) throws org.omg.CosEventComm.Disconnected {
	System.out.println("pull : "+event.toString());
	structuredProxyPullConsumer.pull_structured_event(event.toStructuredEvent());
	}*/

}
