
import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import java.util.*;

import easyNotify.*;

/**
 * vnement 
 *
 * cet vnement fait passer deux valeurs : 
 *     une string reprsentant le nom d'une personne
 *     l'vnement qui lui arrive
 **/
public class MyEvent extends EasyStructuredEvent {
    final static String DOMAIN_NAME = "TEST";
    final static String DOMAIN_TYPE = "MyEvent";

    final static String NOM = "Name";
    final static String EVT = "CivilEvent";

    protected String name;
    protected String event;

    public MyEvent(ORB orb, String nomPersonne, String evennement) {
	super(orb, DOMAIN_NAME, DOMAIN_TYPE, nomPersonne+evennement);

	// mmorisation des donnes
	this.name = nomPersonne;
	this.event = evennement;

	// positionnement du body
	Property[] body = new Property[2];
	body[0] = new Property(NOM, string2Any(nomPersonne));
	body[1] = new Property(EVT, string2Any(evennement));
	setBody(body);
    }


    public MyEvent(StructuredEvent event) throws BadEvent {
	super(event);

	// extraction du body spcifique  cet vnement
	name = null;
	event = null;
	if (domainName.equals(DOMAIN_NAME) && typeName.equals(DOMAIN_TYPE)) {
	    for (int i = 0 ; i < body.length ; i++) {
// 		System.out.println("test du champ de nom = " + body[i].name + " comparaison avec " + NOM);
		if (body[i].name.equals(NOM)) {
		    this.name = body[i].value.extract_string();
// 		    System.out.println("name = " + this.name);
		} else
// 		    System.out.println(" comparaison avec " + EVT);
		    if (body[i].name.equals(EVT)) {
		    this.event = body[i].value.extract_string();
// 		    System.out.println("CivilEvent = " + this.event);
		}
	    }
	    // mal renseign!
	    if ((this.event == null) || (this.name == null)) {
		System.err.println("Evnement bien typ, mais mal renseign");
		throw new BadEvent();
	    }
	} else {
	    // mauvais type
	    System.err.println("Evnement mal typ");
	    throw new BadEvent();
	}
    }



    /**
     * rcupration du nom de la personne.
     *
     * ATTENTION  ne pas confondre avec le nom de l'vnement au sens
     * CORBA qui se trouve dans le Header. ICI le vocabulaire est li 
     * l'application, pas au support CORBA.
     **/
    public String getFieldName() {
	return name;
    }

    /**
     * rcupration du nom de l'vnement qui est arriv  la personne
     *
     * ATTENTION  ne pas confondre avec le nom de l'vnement au sens
     * CORBA qui se trouve dans le Header. ICI le vocabulaire est li
     *  l'application, pas au support CORBA
     **/
    public String getFieldEvent() {
	return event;
    }

    /**
     * surcharge du toString pour qu'il affiche bien le body
     **/
    public String filterableBodyToString() {
	String toReturn = "<FilterableBody>";
	toReturn = toReturn + "<"+NOM+">"+name+"</"+NOM+">";
	toReturn = toReturn + "<"+EVT+">"+event+"</"+EVT+">";
	return toReturn = toReturn + "</FilterableBody>";
    }
}
