
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotification.*;

import easyNotify.*;


public class SocialSecurity implements EasyStructuredPushEventDealer {
    final static String NOTIFICATION_SERVICE_MACHINE = "localHost";
    final static String NOTIFICATION_SERVICE_PORT    = "10001";

    ORB orb;
    POA poa;
    EasyNotifyStructuredPushConsumer easyConsumer;



    /**
     * ici aussi les rfrences  la machine supportant le service de
     * notification sont connues. Si tel n'tait pas le cas, il
     * faudrait les obtenir d'une manire ou d'un autre : passage de
     * paramtres, fichier de configuration...)
     **/
    public SocialSecurity(ORB orb, POA poa) {
	this.orb = orb;
	this.poa = poa;
	try {
	    easyConsumer = new EasyNotifyStructuredPushConsumer(orb, poa, NOTIFICATION_SERVICE_MACHINE, NOTIFICATION_SERVICE_PORT, this);
	} catch (Exception e) {
	    // seule exception possible : org.omg.CosNotification.UnsupportedQoS
	    // nous ne prcisons pas ici les politiques... on n'a donc pas de souci.
	    //
	    // note : il serait possible de catcher au niveau du constructeur, mais pas fait... 
	    e.printStackTrace();
	}
    }
	

    public void run() {
	try {
	    easyConsumer.connect();
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    //*************************************************************
    //*************************************************************
    //
    //       Oprations de l'interface EasyStructuredEventDealer
    //
    //*************************************************************
    //*************************************************************
    public void treatEvent(StructuredEvent event) {
	try {
	    MyEvent myEvent = new MyEvent(event);
	    System.out.println(myEvent.getFieldName()+" "+ myEvent.getFieldEvent());
	    if (myEvent.getFieldEvent().equals("mort")) {
		System.out.println("... c'est fini pour lui");
	    } else if (myEvent.getFieldEvent().equals("marillage")) {
		System.out.println("Et on n'est mme pas invits!!!");
	    } else {
		System.out.println("Et encore un de plus!");
	    }
	} catch (BadEvent e) {
	    e.printStackTrace();
	    System.err.println(new EasyStructuredEvent(event).toString());
	}

    }
}
