
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotification.*;

import easyNotify.*;


public class SocialSecurityPull {
    final static String NOTIFICATION_SERVICE_MACHINE = "localHost";
    final static String NOTIFICATION_SERVICE_PORT    = "10001";
    final private int MAX_ESSAI = 10;

    ORB orb;
    POA poa;
    EasyNotifyStructuredPullConsumer easyConsumer;



    /**
     * ici aussi les rfrences  la machine supportant le service de
     * notification sont connues. Si tel n'tait pas le cas, il
     * faudrait les obtenir d'une manire ou d'un autre : passage de
     * paramtres, fichier de configuration...)
     **/
    public SocialSecurityPull(ORB orb, POA poa) {
	this.orb = orb;
	this.poa = poa;
	try {
	    easyConsumer = new EasyNotifyStructuredPullConsumer(orb, poa, NOTIFICATION_SERVICE_MACHINE, NOTIFICATION_SERVICE_PORT);
	} catch (Exception e) {
	    // seule exception possible : org.omg.CosNotification.UnsupportedQoS
	    // nous ne prcisons pas ici les politiques... on n'a donc pas de souci.
	    //
	    // note : il serait possible de catcher au niveau du constructeur, mais pas fait... 
	    e.printStackTrace();
	}
    }
    

    public void run() {
	try {
	    easyConsumer.connect();
	    StructuredEvent event = null;
	    int essai = 0;
	    BooleanHolder has_event = new BooleanHolder();
	    
	    while (essai < MAX_ESSAI) {
		Thread.sleep(3000);
		System.out.print(".");
		event = easyConsumer.try_pull(has_event);
		if(has_event.value) {
		    essai = 0;
		    treatEvent(event);
		}
		essai++;
	    }
	    if (essai == MAX_ESSAI) {
		System.out.println("\nAucun evenement a recevoir.\nDeconnexion");
		System.exit(0);
	    }
	    easyConsumer.disconnect();

	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    //*************************************************************
    //*************************************************************
    //
    //       Oprations de l'interface EasyStructuredEventDealer
    //
    //*************************************************************
    //*************************************************************
    public void treatEvent(StructuredEvent event) {
	try {
	    MyEvent myEvent = new MyEvent(event);
	    System.out.println(myEvent.getFieldName()+" "+ myEvent.getFieldEvent());
	    if (myEvent.getFieldEvent().equals("mort")) {
		System.out.println("... c'est fini pour lui");
	    } else if (myEvent.getFieldEvent().equals("marillage")) {
		System.out.println("Et on n'est mme pas invits!!!");
	    } else if (myEvent.getFieldEvent().equals("naissance")) {
		System.out.println("Oh le zolie BB");
	    } else {
		System.out.println("Et encore un de plus!");
	    }
	} catch (BadEvent e) {
	    e.printStackTrace();
	    System.err.println(new EasyStructuredEvent(event).toString());
	}

    }
}
